# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section		free

Name:		servletapi6
Version:	6.0.10
Release:	3jpp
Epoch:		0
Summary:	Java servlet and JSP implementation classes
License: 	Apache License 2
Group: 		Internet/WWW/Dynamic Content
Source0:	apache-tomcat-%{version}-src.tar.gz
Source1:	servletapi6-servlet-build.xml
Source2:	servletapi6-jsp-build.xml
Url: 		http://tomcat.apache.org/
#Requires(post,postun):       /usr/sbin/update-alternatives
BuildRequires:  jpackage-utils >= 1.6
BuildRequires:	ant >= 1.6.5
BuildRequires:  java-javadoc
BuildRequires:  coreutils
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot
Provides:	servlet
Provides:	servlet6
Provides:	servlet25

%description
This subproject contains the source code for the implementation classes
of the Java Servlet 2.5 and JSP 2.1 APIs (packages javax.servlet).

%package javadoc
Group: 			Development/Documentation
Summary: 		Javadoc for %{name}

%description javadoc
Javadoc generated Documentation for %{name}.

%prep
rm -rf $RPM_BUILD_ROOT
%setup -q -c -T -a 0 -n apache-servletapi-6-src

%build
cd apache-tomcat-%{version}-src/java

find . -type f -name "*.jar" -exec rm -f {} \;

# Servlet
echo "Build Servelet API"
cp %SOURCE1 build.xml
ant dist -Dservletapi.build=build -Dservletapi.dist=dist

# JSP
echo "Build JSP API"
echo `pwd`
cp %SOURCE2 build.xml
ant dist -Dservletapi.build=build -Dservletapi.dist=dist


%install
cd apache-tomcat-%{version}-src
pushd java
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

install -m 644 dist/lib/jsp-api.jar $RPM_BUILD_ROOT%{_javadir}/jspapi6-%{version}.jar
install -m 644 dist/lib/servlet-api.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc jsp
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/jsp-api-%{version}
cp -pr build/docs/api/javax/servlet/jsp/* $RPM_BUILD_ROOT%{_javadocdir}/jsp-api-%{version}
#ln -s jsp-api-%{version} $RPM_BUILD_ROOT%{_javadocdir}/jsp-api # ghost symlink

# javadoc servlet
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/docs/api/javax/servlet/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
#ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

popd

# License files
cp -p LICENSE $RPM_BUILD_ROOT%{_javadocdir}/jsp-api-%{version}
cp -p NOTICE $RPM_BUILD_ROOT%{_javadocdir}/jsp-api-%{version}
cp -p LICENSE $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -p NOTICE $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}


%clean
rm -rf $RPM_BUILD_ROOT

#%post
#update-alternatives --install %{_javadir}/servlet.jar servlet %{_javadir}/%{name}-%{version}.jar 60
##update-alternatives --install %{_javadir}/jsp.jar jsp %{_javadir}/jsp-api-%{version}.jar 50

#%postun
#if [ "$1" = "0" ]; then
#	update-alternatives --remove servlet %{_javadir}/%{name}-%{version}.jar
##	update-alternatives --remove jsp %{_javadir}/jsp-api-%{version}.jar
#fi

#%post javadoc
#rm -f %{_javadocdir}/%{name}
#rm -f %{_javadocdir}/jsp-api
#ln -s %{name}-%{version} %{_javadocdir}/%{name}
#ln -s jsp-api-%{version} %{_javadocdir}/jsp-api

%files
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}/LICENSE
%doc %{_javadocdir}/%{name}-%{version}/NOTICE
%doc %{_javadocdir}/jsp-api-%{version}/LICENSE
%doc %{_javadocdir}/jsp-api-%{version}/NOTICE
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_javadir}/jspapi6-%{version}.jar
%{_javadir}/jspapi6.jar

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/jsp-api-%{version}
#%ghost %doc %{_javadocdir}/%{name}
#%ghost %doc %{_javadocdir}/jsp-api


%changelog
* Fri Mar 23 2007 Fernando Nasser <fnasser@redhat.com> 0:6.0.10-3jpp
- Add symlinks without version
- List file explicitly

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com> 0:6.0.10-2jpp
- Add missing .properties files

* Fri Mar 09 2007 Fernando Nasser <fnasser@redhat.com> 0:6.0.10-1jpp
- First servlet 2.5 version
- No unversioned symlinks in this "progressive" package
- Similarly, no unversioned doc symlinks
- No alternatives, not compatible with previous versions
  From Andrew Overholt <overholt@redhat.com>:
- add coreutils BuildRequires

* Fri Jan 23 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.18-1jpp
- Update to 5.0.18

* Wed Jan 21 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-2jpp
- Provide servlet, servlet5 and servlet24 (suggestion by Ralph Apel)

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-1jpp
- First build for JPackage

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.2
- First build for internal use only
- Alternatives aren't enabled
- Was unable to figure out how to combine the javadoc trees so they
  stay separate
- Don't obsolete servletapi4 for now
